-- [ja] ルール
--[[
	基本的にキー操作とサウンドはoverlayのほうで設定 
	楽曲情報や必要な変数、画面遷移もすべてoverlayで処理 
	他はあくまで表示内容だけ設定 
--]]
local t = LoadFallbackB();
local act = Def.ActorFrame{
	FOV=60;
	StartMessageCommand=cmd(playcommand,"Off");
	LoadActor(THEME:GetPathG("ScreenWithMenuElements","header"))..{
		InitCommand=function(self)
			self:x(SCREEN_CENTER_X);
			self:y(SCREEN_TOP);
		end;
	};
	Def.Sprite{
		InitCommand=cmd(Center;addy,-20);
		SetSongMessageCommand=function(self,params)
			if params.Song then
				self:LoadBackground(GetEXFSongState_Jacket(GetEXFCurrentSong()));
			end;
		end;
	};
	Def.Sprite{
		InitCommand=cmd(Center;zoom,0.6;addx,210;addy,-40;rotationy,40);
		SetSongMessageCommand=function(self,params)
			if params.Song then
				self:LoadBackground(GetEXFSongState_Jacket(GetEXFSongR(1)));
			end;
		end;
	};
	Def.Sprite{
		InitCommand=cmd(Center;zoom,0.6;addx,-210;addy,-40;rotationy,-40);
		SetSongMessageCommand=function(self,params)
			if params.Song then
				self:LoadBackground(GetEXFSongState_Jacket(GetEXFSongR(-1)));
			end;
		end;
	};
	-- [ja] タイトル 
	LoadFont('Common Normal')..{
		InitCommand=cmd(Center;addy,140;strokecolor,0,0,0,1.0);
		SetSongMessageCommand=function(self,params)
			if params.Song then
				self:diffuse(GetEXFSongState_Color(GetEXFCurrentSong()));
				self:settext(GetEXFSongState_Title(GetEXFCurrentSong()));
			else
				self:settext('');
			end;
		end;
	};
	-- [ja] サブタイトル 
	LoadFont('Common Normal')..{
		InitCommand=cmd(Center;addy,160;strokecolor,0,0,0,1.0;zoom,0.8);
		SetSongMessageCommand=function(self,params)
			if params.Song then
				self:diffuse(GetEXFSongState_Color(GetEXFCurrentSong()));
				self:settext(GetEXFSongState_SubTitle(GetEXFCurrentSong()));
			else
				self:settext('');
			end;
		end;
	};
	-- [ja] アーティスト 
	LoadFont('Common Normal')..{
		InitCommand=cmd(Center;addy,180;strokecolor,0,0,0,1.0;zoom,0.9);
		SetSongMessageCommand=function(self,params)
			if params.Song then
				self:settext(GetEXFSongState_Artist(GetEXFCurrentSong()));
			else
				self:settext('');
			end;
		end;
	};
};
-- [ja] 難易度部分 
for pn in ivalues(PlayerNumber) do
	if GAMESTATE:IsPlayerEnabled(pn) then
		act[#act+1] = Def.ActorFrame{
			InitCommand=function(self)
				if pn==PLAYER_1 then
					(cmd(x,SCREEN_LEFT+60;y,SCREEN_CENTER_Y+100))(self);
				else
					(cmd(x,SCREEN_RIGHT-60;y,SCREEN_CENTER_Y+100))(self);
				end;
			end;
			-- [ja] プレイヤー番号 
			LoadFont('Common Normal')..{
				InitCommand=cmd(diffuse,0,0,0,1;strokecolor,1,1,1,1;
						zoom,0.8;horizalign,(pn==PLAYER_1) and left or right;
						settext,string.upper(ToEnumShortString(pn)));
			};
			-- [ja] 難易度名 
			LoadFont('Common Normal')..{
				InitCommand=cmd(diffuse,0,0,0,1;strokecolor,1,1,1,1;
						y,30;horizalign,(pn==PLAYER_1) and left or right);
				SetSongMessageCommand=function(self,params)
					if params.Song then
						local dif=GAMESTATE:GetCurrentSteps(pn):GetDifficulty();
						self:diffuse(CustomDifficultyToDarkColor(dif));
						self:settext(string.upper(ToEnumShortString(dif)));
					else
						self:settext('');
					end;
				end;
			};
			-- [ja] 難易度数値（Hidden設定の場合は「??」になる） 
			LoadFont('Common Normal')..{
				InitCommand=cmd(diffuse,0,0,0,1;strokecolor,1,1,1,1;
						zoom,1.5;y,60;horizalign,(pn==PLAYER_1) and left or right);
				SetSongMessageCommand=function(self,params)
					if params.Song then
						local dif=GAMESTATE:GetCurrentSteps(pn):GetDifficulty();
						self:diffuse(CustomDifficultyToDarkColor(dif));
						if GetEXFCurrentSong_ShowStepInfo() then
							self:settext(GAMESTATE:GetCurrentSteps(pn):GetMeter());
						else
							self:settext('??');
						end;
					else
						self:settext('');
					end;
				end;
			};
		};
	end;
end;

t[#t+1] = act;
return t;